/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2019 - 2023 Johannes Schneider, Benjamin Hassenfratz, Balthasar Weitzel, Ben Burkhard
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.api.grapevine;

import de.fhg.iese.dd.platform.api.framework.modifiers.ObjectGraphWalker;
import de.fhg.iese.dd.platform.api.grapevine.clientmodel.ClientComment;
import de.fhg.iese.dd.platform.api.grapevine.clientmodel.ClientGroup;
import de.fhg.iese.dd.platform.api.grapevine.clientmodel.ClientPost;
import de.fhg.iese.dd.platform.api.grapevine.clientmodel.GrapevineClientModelMapper;
import de.fhg.iese.dd.platform.api.participants.person.clientmodel.BaseClientPerson;
import de.fhg.iese.dd.platform.api.shared.BaseSharedTestHelper;
import de.fhg.iese.dd.platform.business.grapevine.services.IGroupService;
import de.fhg.iese.dd.platform.business.shared.app.services.IAppService;
import de.fhg.iese.dd.platform.business.shared.feature.services.IFeatureService;
import de.fhg.iese.dd.platform.datamanagement.grapevine.DorfFunkConstants;
import de.fhg.iese.dd.platform.datamanagement.grapevine.config.GrapevineConfig;
import de.fhg.iese.dd.platform.datamanagement.grapevine.feature.GroupAccessibilityApprovalRequiredFeature;
import de.fhg.iese.dd.platform.datamanagement.grapevine.model.*;
import de.fhg.iese.dd.platform.datamanagement.grapevine.repos.*;
import de.fhg.iese.dd.platform.datamanagement.grapevine.repos.results.GroupIdMetaData;
import de.fhg.iese.dd.platform.datamanagement.grapevine.roles.GroupMembershipAdmin;
import de.fhg.iese.dd.platform.datamanagement.motivation.MotivationConstants;
import de.fhg.iese.dd.platform.datamanagement.participants.geoarea.model.GeoArea;
import de.fhg.iese.dd.platform.datamanagement.participants.person.model.Person;
import de.fhg.iese.dd.platform.datamanagement.shared.app.model.App;
import de.fhg.iese.dd.platform.datamanagement.shared.app.model.AppVariant;
import de.fhg.iese.dd.platform.datamanagement.shared.app.model.AppVariantUsage;
import de.fhg.iese.dd.platform.datamanagement.shared.app.repos.AppRepository;
import de.fhg.iese.dd.platform.datamanagement.shared.app.repos.AppVariantRepository;
import de.fhg.iese.dd.platform.datamanagement.shared.app.repos.AppVariantUsageAreaSelectionRepository;
import de.fhg.iese.dd.platform.datamanagement.shared.app.repos.AppVariantUsageRepository;
import de.fhg.iese.dd.platform.datamanagement.shared.feature.model.FeatureConfig;
import de.fhg.iese.dd.platform.datamanagement.shared.feature.repos.FeatureConfigRepository;
import de.fhg.iese.dd.platform.datamanagement.shared.misc.model.GPSLocation;
import de.fhg.iese.dd.platform.datamanagement.shared.push.model.PushCategory;
import de.fhg.iese.dd.platform.datamanagement.shared.security.model.OauthClient;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.tuple.Pair;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;

import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import static de.fhg.iese.dd.platform.api.participants.person.controllers.modifiers.BaseLastNameShorteningModifier.shorten;
import static org.assertj.core.api.Assertions.assertThat;
import static org.junit.jupiter.api.Assertions.*;

/**
 * Creates some group related test entities. Current configuration can be generated by calling {@link
 * GroupTestHelper#printExampleGroupOverview()}:
 */
@Component
public final class GroupTestHelper extends BaseSharedTestHelper {

    @Autowired
    public AppRepository appRepository;
    @Autowired
    public AppVariantRepository appVariantRepository;
    @Autowired
    public AppVariantUsageRepository appVariantUsageRepository;
    @Autowired
    public AppVariantUsageAreaSelectionRepository appVariantUsageAreaSelectionRepository;
    @Autowired
    public GrapevineConfig grapevineConfig;
    @Autowired
    public PostRepository postRepository;
    @Autowired
    public CommentRepository commentRepository;
    @Autowired
    public GroupRepository groupRepository;
    @Autowired
    public GroupGeoAreaMappingRepository groupGeoAreaMappingRepository;
    @Autowired
    public GroupMembershipRepository groupMembershipRepository;
    // We directly use the model mapper here since its correctness is already (implicitly) tested in PostControllerTest
    @Autowired
    private GrapevineClientModelMapper grapevineClientModelMapper;
    @Autowired
    private FeatureConfigRepository FeatureConfigRepository;
    @Autowired
    private IFeatureService featureService;
    @Autowired
    private IAppService appService;

    public Person personAnjaTenant1Dorf1;
    public Person personBenTenant1Dorf2;
    public Person personChloeTenant1Dorf1;
    public Person personDagmarTenant2Mainz;
    public Person personDieterTenant2MainzNoMember;
    public Person personEckhardTenant1Dorf1NoMember;
    public Person personFranziTenant1Dorf2NoMember;

    public App app;
    public OauthClient appVariantKL_EBOauthClient;
    public AppVariant appVariantKL_EB;
    public OauthClient appVariantMZOauthClient;
    public AppVariant appVariantMZ;

    // last digits correspond to
    // visibility  ([A]nyone, [S]ame home area, [M]embers)
    // content visibility ([A]nyone, [S]ame home area, [M]embers)
    // accessibility ([P]ublic, [A]pproval required)
    public Group groupAdfcAAP;
    public Group groupSchachvereinAAA;
    public Group groupWaffenfreundeAMA;
    public Group groupGlasfaserSSP;
    public Group groupDorfgeschichteSSA;
    public Group groupMessdienerSMA;
    public Group groupErfahrungMMA;
    public Group groupDeleted;
    public Group groupMuellAAP;
    public Group groupKatzenAAP;

    public MultiValueMap<Group, Pair<Gossip, List<Comment>>> groupsToPostsAndComments;
    public Map<Group, IGroupService.GroupGeoAreas> groupToGeoAreaMapping;

    public Pair<Gossip, List<Comment>> gossipDorf1WithComments;
    public Pair<Gossip, List<Comment>> gossipMainzWithComments;

    @Override
    public void createPersons() {
        super.createPersons();

        personAnjaTenant1Dorf1 = createPersonWithDefaultAddress("Anja", tenant1, geoAreaDorf1InEisenberg,
                "8bc8e7bb-9ad5-41b6-af6d-2284c0578283");
        personBenTenant1Dorf2 = createPersonWithDefaultAddress("Ben", tenant1, geoAreaDorf2InEisenberg,
                "ec548e22-85c8-4666-ad56-fd0458c70e5a");
        personChloeTenant1Dorf1 = createPersonWithDefaultAddress("Chloe", tenant1, geoAreaDorf1InEisenberg,
                "b888f098-1841-41b0-a499-bc92c6879d3d");
        personDagmarTenant2Mainz = createPersonWithDefaultAddress("Dagmar", tenant2, geoAreaMainz,
                "ebaa0e30-20c7-4496-b28a-242ccc9a7276");
        personDieterTenant2MainzNoMember = createPersonWithDefaultAddress("Dieter", tenant2, geoAreaMainz,
                "42a5caf0-f9e4-4380-8997-0d7ebe77ad5a");
        personEckhardTenant1Dorf1NoMember = createPersonWithDefaultAddress("Eckhard", tenant1, geoAreaDorf1InEisenberg,
                "d8a0f040-0136-4722-9caf-dfddb78fd4bc");
        personFranziTenant1Dorf2NoMember = createPersonWithDefaultAddress("Franzi", tenant1, geoAreaDorf2InEisenberg,
                "4e8ca138-d15b-4f8e-a1dd-5a15fb35deb2");
    }

    @Override
    public void createAppEntities() {

        if (!ObjectUtils.allNotNull(geoAreaMainz, geoAreaEisenberg, geoAreaDorf1InEisenberg,
                geoAreaDorf2InEisenberg, tenant1, tenant2, personAnjaTenant1Dorf1, personBenTenant1Dorf2,
                personDagmarTenant2Mainz)) {
            throw new IllegalStateException("add th.createTenantsAndGeoAreas() and th.createPersons() to your " +
                    "test before calling this method!");
        }

        app = appRepository.save(App.builder()
                .id(DorfFunkConstants.APP_ID)
                .name("DorfFunky")
                .appIdentifier("dd-dorf-funky")
                .build());

        appVariantKL_EBOauthClient = oauthClientRepository.save(OauthClient.builder()
                .oauthClientIdentifier("appVariantKL_EBOauthClient-identifier")
                .build());
        appVariantKL_EB = appVariantRepository.save(AppVariant.builder()
                .app(app)
                .oauthClients(Collections.singleton(appVariantKL_EBOauthClient))
                .appVariantIdentifier("DorfFunky-variant-kl-eb")
                .build());
        mapGeoAreaToAppVariant(appVariantKL_EB, geoAreaEisenberg, tenant1);
        mapGeoAreaToAppVariant(appVariantKL_EB, geoAreaKaiserslautern, tenant1);

        appVariantMZOauthClient = oauthClientRepository.save(OauthClient.builder()
                .oauthClientIdentifier("appVariantMZOauthClient-identifier")
                .build());
        appVariantMZ = appVariantRepository.save(AppVariant.builder()
                .app(app)
                .oauthClients(Collections.singleton(appVariantMZOauthClient))
                .appVariantIdentifier("DorfFunky-variant-mz")
                .build());
        mapGeoAreaToAppVariant(appVariantMZ, geoAreaMainz, tenant2);

        selectGeoAreaForAppVariant(appVariantKL_EB, personAnjaTenant1Dorf1, geoAreaDorf1InEisenberg);
        selectGeoAreaForAppVariant(appVariantKL_EB, personAnjaTenant1Dorf1, geoAreaEisenberg);
        selectGeoAreaForAppVariant(appVariantMZ, personAnjaTenant1Dorf1, geoAreaMainz);

        selectGeoAreaForAppVariant(appVariantKL_EB, personBenTenant1Dorf2, geoAreaDorf2InEisenberg);
        selectGeoAreaForAppVariant(appVariantKL_EB, personBenTenant1Dorf2, geoAreaEisenberg);
        selectGeoAreaForAppVariant(appVariantMZ, personBenTenant1Dorf2, geoAreaMainz);

        selectGeoAreaForAppVariant(appVariantKL_EB, personChloeTenant1Dorf1, geoAreaDorf1InEisenberg);
        selectGeoAreaForAppVariant(appVariantKL_EB, personChloeTenant1Dorf1, geoAreaEisenberg);

        selectGeoAreaForAppVariant(appVariantMZ, personDagmarTenant2Mainz, geoAreaMainz);

        selectGeoAreaForAppVariant(appVariantKL_EB, personEckhardTenant1Dorf1NoMember, geoAreaDorf1InEisenberg);
        selectGeoAreaForAppVariant(appVariantKL_EB, personEckhardTenant1Dorf1NoMember, geoAreaEisenberg);
        selectGeoAreaForAppVariant(appVariantMZ, personEckhardTenant1Dorf1NoMember, geoAreaMainz);

        selectGeoAreaForAppVariant(appVariantKL_EB, personFranziTenant1Dorf2NoMember, geoAreaDorf2InEisenberg);
        selectGeoAreaForAppVariant(appVariantKL_EB, personFranziTenant1Dorf2NoMember, geoAreaEisenberg);
        selectGeoAreaForAppVariant(appVariantMZ, personFranziTenant1Dorf2NoMember, geoAreaMainz);

        selectGeoAreaForAppVariant(appVariantKL_EB, personDieterTenant2MainzNoMember, geoAreaKaiserslautern);
        selectGeoAreaForAppVariant(appVariantMZ, personDieterTenant2MainzNoMember, geoAreaMainz);
    }

    @Override
    public void createPushEntities() {

        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_POST_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_GOSSIP_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_NEWSITEM_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_SUGGESTION_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_SEEKING_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_OFFER_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_HAPPENING_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_POST_IN_GROUP_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_POST_CHANGED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_POST_DELETED);

        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_COMMENT_CREATED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_COMMENT_CHANGED);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_COMMENT_DELETED);

        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_COMMENT_ON_POST);
        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_COMMENT_REPLY);

        createPushCategory(app, DorfFunkConstants.PUSH_CATEGORY_ID_GROUP_MEMBER_STATUS_CHANGED);

        pushCategoryRepository.save(PushCategory.builder()
                .app(app)
                .name("Achievements")
                .description("Achievements")
                .subject(MotivationConstants.PUSH_CATEGORY_SUBJECT)
                .defaultLoudPushEnabled(true)
                .build()
                .withId(DorfFunkConstants.PUSH_CATEGORY_ID_MOTIVATION));
    }

    public void createGroupsAndGroupPostsWithComments() {
        if (ObjectUtils.anyNull(geoAreaTenant2, geoAreaEisenberg, geoAreaDorf1InEisenberg,
                personChloeTenant1Dorf1,
                geoAreaDorf2InEisenberg, tenant1, tenant2, personAnjaTenant1Dorf1, personBenTenant1Dorf2,
                personDagmarTenant2Mainz)) {
            throw new IllegalStateException("add th.createTenantsAndGeoAreas() and th.createPersons() to your " +
                    "test before calling this method!");
        }

        groupsToPostsAndComments = new LinkedMultiValueMap<>();

        // ==== groupAdfcAAP =============================================================
        groupAdfcAAP = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.ANYONE)
                .contentVisibility(GroupContentVisibility.ANYONE)
                .accessibility(GroupAccessibility.PUBLIC)
                .deleted(false)
                .tenant(tenant1)
                .name("Regionalgruppe ADFC " + tenant1.getName())
                .shortName("IG")
                .logo(createMediaItem("fahhradlogo.png"))
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupAdfcAAP)
                .geoArea(geoAreaEisenberg)
                .excluded(false)
                .build()
                .withConstantId());

        // first gossip
        Gossip gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupAdfcAAP)
                .creator(personAnjaTenant1Dorf1)
                .geoAreas(Set.of(personAnjaTenant1Dorf1.getHomeArea()))
                .createdLocation(new GPSLocation(47.123, 9.321))
                .images(Collections.singletonList(createMediaItem("feuerwerk.png")))
                .text("Willkommen an alle ADFC-Mitglieder und -Interessenten. Hier können wir über Aktionen informieren" +
                        " und Vorschläge sammeln.")
                .build());

        Pair<Gossip, List<Comment>> gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupAdfcAAP, gossipWithComments);

        // first gossip, first comment
        Comment comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personBenTenant1Dorf2)
                .deleted(false)
                .text("Hi, ich bin auch dabei! Gruß in die Runde!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        // first gossip, second comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personAnjaTenant1Dorf1)
                .deleted(false)
                .text("Hallo und willkommen!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        // first gossip, third comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personBenTenant1Dorf2)
                .deleted(false)
                .text("Danke! *freu*")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        // second gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupAdfcAAP)
                .creator(personBenTenant1Dorf2)
                .geoAreas(Set.of(personBenTenant1Dorf2.getHomeArea()))
                .createdLocation(new GPSLocation(47.123, 9.321))
                .text("Hat jemand Erfahrung mit Liegerädern?")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupAdfcAAP, gossipWithComments);

        // second gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personChloeTenant1Dorf1)
                .deleted(false)
                .text("Der Holger hat eins! Komm doch mal beim nächsten Treffen vorbei, immer am zweiten Mittwoch " +
                        "im 'Lokschuppen'.")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        // second gossip, third (deleted) comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personAnjaTenant1Dorf1)
                .deleted(true)
                .text("Liegeräder sind was für alte Leute mit Rückenproblemen")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        // third (deleted) gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupAdfcAAP)
                .creator(personChloeTenant1Dorf1)
                .geoAreas(Set.of(personChloeTenant1Dorf1.getHomeArea()))
                .createdLocation(new GPSLocation(47.123, 9.321))
                .text("Mein Fahrrad ist kaputt, wer kann mir helfen?")
                .deleted(true)
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupAdfcAAP, gossipWithComments);

        // fourth gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupAdfcAAP)
                .creator(personChloeTenant1Dorf1)
                .geoAreas(Set.of(personChloeTenant1Dorf1.getHomeArea()))
                .createdLocation(new GPSLocation(47.123, 9.321))
                .text("Moin, zur Info an alle: Unser Treffen ist jeden zweiten Mittwoch im 'Lokschuppen'.")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupAdfcAAP, gossipWithComments);

        // Set group admin role for group admin visibility test cases
        assignRoleToPerson(personBenTenant1Dorf2, GroupMembershipAdmin.class, groupAdfcAAP.getId());
        assignRoleToPerson(personChloeTenant1Dorf1, GroupMembershipAdmin.class, groupAdfcAAP.getId());

        // ==== groupSchachvereinAAA =============================================================
        groupSchachvereinAAA = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.ANYONE)
                .contentVisibility(GroupContentVisibility.ANYONE)
                .accessibility(GroupAccessibility.APPROVAL_REQUIRED)
                .deleted(false)
                .tenant(tenant1)
                .name("Schachverein Rochade")
                .shortName("SR")
                .logo(createMediaItem("chess.png"))
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupSchachvereinAAA)
                .geoArea(geoAreaDorf1InEisenberg)
                .build()
                .withConstantId());

        // first gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupSchachvereinAAA)
                .creator(personBenTenant1Dorf2)
                .geoAreas(Set.of(personBenTenant1Dorf2.getHomeArea()))
                .text("Super, dass wir jetzt eine Gruppe haben!")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupSchachvereinAAA, gossipWithComments);

        // Set group admin role for pending join test cases
        assignRoleToPerson(personBenTenant1Dorf2, GroupMembershipAdmin.class, groupSchachvereinAAA.getId());

        // ==== groupWaffenfreundeAMA =============================================================
        groupWaffenfreundeAMA = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.ANYONE)
                .contentVisibility(GroupContentVisibility.MEMBERS)
                .accessibility(GroupAccessibility.APPROVAL_REQUIRED)
                .deleted(false)
                .tenant(tenant1)
                .name("Waffenfreunde \"Schießen lernen, Freunde treffen\"")
                .shortName("WF")
                .logo(createMediaItem("donald_trump.png"))
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupWaffenfreundeAMA)
                .geoArea(geoAreaDorf1InEisenberg)
                .build()
                .withConstantId());

        // first gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupWaffenfreundeAMA)
                .creator(personChloeTenant1Dorf1)
                .geoAreas(Set.of(personChloeTenant1Dorf1.getHomeArea()))
                .text("Kann mir jemand sagen, warum es gestern so laut geknallt hat?")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupWaffenfreundeAMA, gossipWithComments);

        // second gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupWaffenfreundeAMA)
                .creator(personAnjaTenant1Dorf1)
                .geoAreas(Set.of(personAnjaTenant1Dorf1.getHomeArea()))
                .text("Will ma wieder Ratten schießn gehn, was nehm ich n da?")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupWaffenfreundeAMA, gossipWithComments);

        // second gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personBenTenant1Dorf2)
                .deleted(false)
                .text("Die armen Tiere!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        // ==== groupGlasfaserSSP =============================================================
        groupGlasfaserSSP = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.SAME_HOME_AREA)
                .contentVisibility(GroupContentVisibility.SAME_HOME_AREA)
                .accessibility(GroupAccessibility.PUBLIC)
                .deleted(false)
                .tenant(tenant1)
                .name("Glasfaser " + geoAreaDorf1InEisenberg.getName())
                .shortName("IG")
                .logo(createMediaItem("glasfaser.png"))
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupGlasfaserSSP)
                .geoArea(geoAreaDorf1InEisenberg)
                .build());

        // first gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupGlasfaserSSP)
                .creator(personChloeTenant1Dorf1)
                .geoAreas(Set.of(personChloeTenant1Dorf1.getHomeArea()))
                .text("WIR WOLLEN ENDLICH SCHNELLES INTERNET!")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupGlasfaserSSP, gossipWithComments);

        // ==== groupDorfgeschichteSSA =============================================================
        groupDorfgeschichteSSA = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.SAME_HOME_AREA)
                .contentVisibility(GroupContentVisibility.SAME_HOME_AREA)
                .accessibility(GroupAccessibility.APPROVAL_REQUIRED)
                .deleted(false)
                .tenant(tenant1)
                .name("Verein für Dorfgeschichte")
                .shortName("DG")
                .logo(createMediaItem(null))
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupDorfgeschichteSSA)
                .geoArea(geoAreaDorf1InEisenberg)
                .build());
        groupsToPostsAndComments.put(groupDorfgeschichteSSA, Collections.emptyList());
        //nix los hier

        // ==== groupMessdienerSMA =============================================================
        groupMessdienerSMA = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.SAME_HOME_AREA)
                .contentVisibility(GroupContentVisibility.MEMBERS)
                .accessibility(GroupAccessibility.APPROVAL_REQUIRED)
                .deleted(false)
                .tenant(tenant1)
                .name("Messdiener " + tenant1.getName())
                .shortName("MD")
                .logo(createMediaItem("kirche.jpg"))
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupMessdienerSMA)
                .geoArea(geoAreaDorf2InEisenberg)
                .build()
                .withConstantId());

        // first gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupMessdienerSMA)
                .creator(personChloeTenant1Dorf1)
                .geoAreas(Set.of(personChloeTenant1Dorf1.getHomeArea()))
                .text("Wichtige Mitteilungen (können wir hier sammeln, als Kommentare!)")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupMessdienerSMA, gossipWithComments);

        // first gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personChloeTenant1Dorf1)
                .deleted(false)
                .text("Morgen Kommunionsgottesdienst, bitte besonders pünktlich sein!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        // first gossip, second comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personChloeTenant1Dorf1)
                .deleted(false)
                .text("Aus gegebenem Anlass möchte ich nochmal darauf hinweisen, dass blinkende Turnschuhe in der " +
                        "Kirche nicht erlaubt sind.")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        // ==== groupVgMMA =============================================================
        groupErfahrungMMA = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.MEMBERS)
                .contentVisibility(GroupContentVisibility.MEMBERS)
                .accessibility(GroupAccessibility.APPROVAL_REQUIRED)
                .deleted(false)
                .tenant(tenant1)
                .name("Erfahrungsaustausch Digitale Dörfer in " + tenant1.getName())
                .shortName("")
                .logo(createMediaItem(""))
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupErfahrungMMA)
                .geoArea(geoAreaEisenberg)
                .build()
                .withConstantId());

        // first gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupErfahrungMMA)
                .creator(personChloeTenant1Dorf1)
                .geoAreas(Set.of(personChloeTenant1Dorf1.getHomeArea()))
                .text("DorfFunk rockt, was meint Ihr?")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupErfahrungMMA, gossipWithComments);

        // first gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personAnjaTenant1Dorf1)
                .deleted(false)
                .text("Ja, Wahnsinn wie viele Leute da jetzt vernetzt sind!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        // first gossip, second comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personBenTenant1Dorf2)
                .deleted(false)
                .text("Und die App funktioniert echt super gut. Bei mir ist sie noch nie abgestürzt!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        // first gossip, third comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personBenTenant1Dorf2)
                .deleted(false)
                .text("Sogar auf meinem alten Handy tut sie noch!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        // second gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupErfahrungMMA)
                .creator(personAnjaTenant1Dorf1)
                .geoAreas(Set.of(personAnjaTenant1Dorf1.getHomeArea()))
                .text("Was meint Ihr zur LösBar?")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupErfahrungMMA, gossipWithComments);

        // second gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personBenTenant1Dorf2)
                .deleted(false)
                .text("Hab sie noch nicht ausprobiert")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        // ==== deletedGroupTenant1AAP =============================================================
        groupDeleted = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.ANYONE)
                .contentVisibility(GroupContentVisibility.ANYONE)
                .accessibility(GroupAccessibility.PUBLIC)
                .deleted(true)
                .deletionTime(nextTimeStamp())
                .tenant(tenant1)
                .name("Kirche des fliegenden Spaghettimonsters")
                .shortName("FS")
                .logo(createMediaItem("pasta.png"))
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupDeleted)
                .geoArea(geoAreaDorf1InEisenberg)
                .build()
                .withConstantId());

        // first gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupDeleted)
                .creator(personChloeTenant1Dorf1)
                .geoAreas(Set.of(personChloeTenant1Dorf1.getHomeArea()))
                .text("Ich mag meine Spaghetti 🍝 al dente, und ihr?")
                .build());
        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupDeleted, gossipWithComments);

        // first gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personAnjaTenant1Dorf1)
                .deleted(false)
                .text("Meißtens knabbere ich sie roh!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        // ==== groupMuellAAP =============================================================
        groupMuellAAP = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.ANYONE)
                .contentVisibility(GroupContentVisibility.ANYONE)
                .accessibility(GroupAccessibility.PUBLIC)
                .deleted(false)
                .tenant(tenant2)
                .name("Müll-Weg-Tag")
                .shortName("MW")
                .logo(null)
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupMuellAAP)
                .geoArea(geoAreaTenant2)
                .build()
                .withConstantId());

        // first gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupMuellAAP)
                .creator(personDagmarTenant2Mainz)
                .geoAreas(Set.of(personDagmarTenant2Mainz.getHomeArea()))
                .text("Wer hilft mit?")
                .build());

        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupMuellAAP, gossipWithComments);

        // first gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personDagmarTenant2Mainz)
                .deleted(false)
                .text("Bitte, meldet Euch!")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        // ==== groupKatzenAAP =============================================================
        groupKatzenAAP = groupRepository.save(Group.builder()
                .visibility(GroupVisibility.ANYONE)
                .contentVisibility(GroupContentVisibility.ANYONE)
                .accessibility(GroupAccessibility.PUBLIC)
                .deleted(false)
                .tenant(tenant3)
                .name("Katzen-Gruppe")
                .shortName("KG")
                .logo(null)
                .build()
                .withCreated(nextTimeStamp()));
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupKatzenAAP)
                .geoArea(geoAreaKaiserslautern)
                .build()
                .withConstantId());
        //not available if Eisenberg is in the available geo areas of the calling app
        groupGeoAreaMappingRepository.save(GroupGeoAreaMapping.builder()
                .group(groupKatzenAAP)
                .geoArea(geoAreaEisenberg)
                .excluded(true)
                .build()
                .withConstantId());

        // first gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .group(groupKatzenAAP)
                .creator(personDagmarTenant2Mainz)
                .geoAreas(Set.of(personDagmarTenant2Mainz.getHomeArea()))
                .text("Ist sie nicht so süß? 🐈")
                .images(Collections.singletonList(createMediaItem("Kätzchen.gif")))
                .build());

        gossipWithComments = Pair.of(gossip, new ArrayList<>());
        groupsToPostsAndComments.add(groupKatzenAAP, gossipWithComments);

        // first gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personDagmarTenant2Mainz)
                .deleted(false)
                .text("Das ist mein Hundi! 🐕💕🐈")
                .build()
                .withCreated(nextTimeStamp()));
        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        groupToGeoAreaMapping = getGeoAreasByGroups();

        //consistency check
        assertEquals(10, groupsToPostsAndComments.size());
        final Set<Group> createdGroups = groupsToPostsAndComments.keySet();

        for (Group createdGroup : createdGroups) {
            assertTrue(groupRepository.existsById(createdGroup.getId()));
            assertThat(groupToGeoAreaMapping.get(createdGroup)).isNotNull();
            assertThat(groupToGeoAreaMapping.get(createdGroup).getIncludedGeoAreas()).isNotEmpty();
            for (Pair<Gossip, List<Comment>> gossipAndComments : groupsToPostsAndComments.get(createdGroup)) {
                final Gossip createdGossip = gossipAndComments.getLeft();
                assertTrue(postRepository.existsById(createdGossip.getId()));
                assertEquals(createdGossip.getGroup(), createdGroup);
                for (Comment createdComment : gossipAndComments.getRight()) {
                    assertTrue(commentRepository.existsById(createdComment.getId()));
                    assertEquals(createdComment.getPost(), createdGossip);
                }
            }
        }

        //add all persons that wrote something in a group as group members
        for (Map.Entry<Group, List<Pair<Gossip, List<Comment>>>> groupListEntry : groupsToPostsAndComments.entrySet()) {
            final Group groupToJoin = groupListEntry.getKey();
            final List<Person> activeGroupPeople = groupListEntry.getValue()
                    .stream()
                    .flatMap(pair -> Stream.concat(Stream.of(pair.getLeft().getCreator()), pair.getRight()
                            .stream()
                            .map(Comment::getCreator)))
                    .distinct()
                    .collect(Collectors.toList());
            for (Person groupPerson : activeGroupPeople) {
                groupMembershipRepository.save(GroupMembership.builder()
                        .group(groupToJoin)
                        .member(groupPerson)
                        .status(GroupMembershipStatus.APPROVED)
                        .build());
            }
            //set the member count correctly
            groupToJoin.setMemberCount(activeGroupPeople.size());
            groupRepository.save(groupToJoin);
        }

        final List<Person> members = groupMembershipRepository.findAll()
                .stream()
                .map(GroupMembership::getMember)
                .distinct()
                .collect(Collectors.toList());
        assertFalse(members.contains(personEckhardTenant1Dorf1NoMember));
        assertFalse(members.contains(personFranziTenant1Dorf2NoMember));
    }

    private Map<Group, IGroupService.GroupGeoAreas> getGeoAreasByGroups() {
        return groupGeoAreaMappingRepository.findAll().stream()
                .collect(Collectors.groupingBy(GroupGeoAreaMapping::getGroup,
                        Collectors.collectingAndThen(Collectors.toList(), this::toGroupGeoAreas)));
    }

    private IGroupService.GroupGeoAreas toGroupGeoAreas(List<GroupGeoAreaMapping> mappings) {

        final Map<Boolean, Set<GeoArea>> geoAreasByExcluded = mappings.stream()
                .collect(Collectors.partitioningBy(GroupGeoAreaMapping::isExcluded,
                        Collectors.mapping(GroupGeoAreaMapping::getGeoArea, Collectors.toSet())));
        final GeoArea mainGeoArea = mappings.stream()
                .filter(GroupGeoAreaMapping::isMainGeoArea)
                .map(GroupGeoAreaMapping::getGeoArea)
                .min(Comparator.comparing(GeoArea::getId))
                .orElse(null);
        return IGroupService.GroupGeoAreas.builder()
                .mainGeoArea(mainGeoArea)
                .includedGeoAreas(geoAreasByExcluded.get(false))
                .excludedGeoAreas(geoAreasByExcluded.get(true))
                .build();
    }

    //copied from GroupService
    public Map<String, IGroupService.GroupGeoAreaIds> findGeoAreaIdsByGroups(Collection<Group> groups) {
        Set<Group> groupSet = new HashSet<>(groups);
        return groupGeoAreaMappingRepository.findAllGeoAreaIdsByGroupIds(Group.toInSafeEntitySet(groupSet)).stream()
                .collect(Collectors.groupingBy(GroupIdMetaData::getGroupId,
                        Collectors.collectingAndThen(Collectors.toList(), this::toGroupGeoAreaIds)));
    }

    //copied from GroupService
    private IGroupService.GroupGeoAreaIds toGroupGeoAreaIds(List<GroupIdMetaData> mappings) {

        final Map<Boolean, Set<String>> geoAreaIdsByExcluded = mappings.stream()
                .collect(Collectors.partitioningBy(GroupIdMetaData::isGeoAreaExcluded,
                        Collectors.mapping(GroupIdMetaData::getGeoAreaId, Collectors.toSet())));
        final String mainGeoAreaId = mappings.stream()
                .filter(GroupIdMetaData::isMainGeoArea)
                .map(GroupIdMetaData::getGeoAreaId)
                .sorted()
                .findFirst()
                .orElse(null);
        return IGroupService.GroupGeoAreaIds.builder()
                .mainGeoAreaId(mainGeoAreaId)
                .includedGeoAreaIds(geoAreaIdsByExcluded.get(false))
                .excludedGeoAreaIds(geoAreaIdsByExcluded.get(true))
                .build();
    }

    public void createAdditionalGossipsAndCommentsWithoutGroup() {

        if (!ObjectUtils.allNotNull(geoAreaTenant2, geoAreaEisenberg, geoAreaDorf1InEisenberg,
                geoAreaDorf2InEisenberg, tenant1, tenant2, personAnjaTenant1Dorf1, personBenTenant1Dorf2,
                personDagmarTenant2Mainz)) {
            throw new IllegalStateException("add th.createTenantsAndGeoAreas and th.createPersons() to your " +
                    "test before calling this method!");
        }

        // first gossip
        Gossip gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant1)
                .geoAreas(Set.of(personAnjaTenant1Dorf1.getHomeArea()))
                .group(null)
                .creator(personAnjaTenant1Dorf1)
                .createdLocation(new GPSLocation(47.123, 9.321))
                .images(Collections.singletonList(createMediaItem("müll.jpg")))
                .text("Wer hat denn da schon wieder alles vollgemüllt?")
                .build());

        Pair<Gossip, List<Comment>> gossipWithComments = Pair.of(gossip, new ArrayList<>());

        // first gossip, first comment
        Comment comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personBenTenant1Dorf2)
                .deleted(false)
                .text("Sin doch alles voll assis hier")
                .build()
                .withCreated(nextTimeStamp()));

        gossipWithComments.getRight().add(comment);

        // first gossip, second comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personEckhardTenant1Dorf1NoMember)
                .deleted(false)
                .text("du meinst, weil du auch hier wohnst?")
                .build()
                .withCreated(nextTimeStamp()));

        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        gossipDorf1WithComments = gossipWithComments;

        // second gossip
        gossip = postRepository.save(Gossip.builder()
                .created(nextTimeStamp())
                .tenant(tenant2)
                .geoAreas(Set.of(personDieterTenant2MainzNoMember.getHomeArea()))
                .group(null)
                .creator(personDieterTenant2MainzNoMember)
                .createdLocation(new GPSLocation(47.123, 9.321))
                .text("Weiß jemand wo man frische Eier bekommt?")
                .build());

        gossipWithComments = Pair.of(gossip, new ArrayList<>());

        // second gossip, first comment
        comment = commentRepository.save(Comment.builder()
                .post(gossip)
                .creator(personDieterTenant2MainzNoMember)
                .deleted(false)
                .text("Hat sich erledigt!")
                .build()
                .withCreated(nextTimeStamp()));

        gossipWithComments.getRight().add(comment);

        //set last comment timestamp
        gossip.setLastActivity(comment.getCreated());
        postRepository.save(gossip);

        gossipMainzWithComments = gossipWithComments;
    }

    public void printGroupSettings(Person caller) {

        appVariantUsageRepository.findAllByPersonOrderByCreatedDesc(caller).stream()
                .map(AppVariantUsage::getAppVariant)
                .forEach(appVariant ->
                        log.debug("Person '{}' living in '{}' using '{}' selected geo areas:\n{}",
                                caller.getFullName(),
                                caller.getHomeArea().getName(),
                                appVariant.getAppVariantIdentifier(),
                                appVariantUsageAreaSelectionRepository
                                        .findAllSelectedGeoAreas(appVariant, caller).stream()
                                        .map(GeoArea::getName)
                                        .collect(Collectors.joining("\n")))
                );

        log.debug("Person '{}' has these group memberships \n{}", caller.getFullName(),
                groupMembershipRepository.findAllByMemberOrderByCreatedDesc(caller).stream()
                        .map(gm -> gm.getGroup().getName() + " (" + gm.getStatus() + ")")
                        .collect(Collectors.joining("\n"))
        );
    }

    public void printAvailableGroups() {
        log.debug("Available groups globally:\n{}",
                groupToGeoAreaMapping.entrySet().stream()
                        .sorted(Comparator.comparing(e -> e.getKey().getName()))
                        .map(e -> String.format("%-40.40s %-7.7s -> %s",
                                e.getKey().getName(),
                                e.getKey().isDeleted() ? "DELETED" : "",
                                getGroupGeoAreaDescription(e.getValue())))
                        .collect(Collectors.joining("\n")));
    }

    public void printAvailableGeoAreas(AppVariant appVariant) {
        log.debug("Available geo areas for {}:\n{}",
                appVariant.getAppVariantIdentifier(),
                appService.getAvailableGeoAreas(appVariant).stream()
                        .sorted(Comparator.comparing(GeoArea::getName))
                        .map(GeoArea::toString)
                        .collect(Collectors.joining("\n")));
    }

    protected void printExampleGroupOverview() {
        List<String> groupInfo = new ArrayList<>();
        groupInfo.add("");
        groupInfo.add("Nr, Name, Visibility, ContentVisibility, Accessibility, GeoArea, Tenant");
        int i = 0;
        for (Group group : groupsToPostsAndComments.keySet()) {
            groupInfo.add(Stream.of(
                    i,
                    (group.isDeleted() ? "(DELETED) " : "") + group.getName(),
                    group.getVisibility(),
                    group.getContentVisibility(),
                    group.getAccessibility(),
                    getGroupGeoAreaDescription(groupToGeoAreaMapping.get(group)),
                    group.getTenant().getName()
                    )
                            .map(Objects::toString)
                            .collect(Collectors.joining(", "))
            );
            groupInfo.add("    members: " + groupMembershipRepository.findAll()
                    .stream()
                    .filter(gm -> gm.getGroup().equals(group))
                    .map(GroupMembership::getMember)
                    .distinct()
                    .map(Person::getFirstName)
                    .map(GroupTestHelper::withoutPrefix)
                    .sorted()
                    .collect(Collectors.joining(", ")));
            final List<Pair<Gossip, List<Comment>>> postsAndComments = groupsToPostsAndComments.get(group);
            for (Pair<Gossip, List<Comment>> postAndComments : postsAndComments) {
                final Gossip post = postAndComments.getLeft();
                groupInfo.add("    " + post.getPostType() + " by " + withoutPrefix(post.getCreator().getFirstName()) +
                        ": \"" + post.getText() + "\"");
                for (Comment comment : postAndComments.getRight()) {
                    groupInfo.add("        Comment by " +
                            withoutPrefix(comment.getCreator().getFirstName() + ": \"" + comment.getText() + "\""));
                }
            }
            i++;
        }
        log.info(String.join("\n", groupInfo));
    }

    private String getGroupGeoAreaDescription(IGroupService.GroupGeoAreas groupGeoAreas) {
        return groupGeoAreas.getIncludedGeoAreas().stream()
                .map(GeoArea::getName)
                .collect(Collectors.joining(", ", "incl(", ")"))
                + "|" +
                groupGeoAreas.getExcludedGeoAreas().stream()
                        .map(GeoArea::getName)
                        .collect(Collectors.joining(", ", "excl(", ")"));
    }

    public void createGroupFeatureConfiguration() {

        setGroupAccessibilityApprovalRequiredFeatureEnabled(appVariantKL_EB, true);
        setGroupAccessibilityApprovalRequiredFeatureEnabled(appVariantMZ, true);
    }

    private static String withoutPrefix(String firstName) {
        return firstName.replace("First ", "");
    }

    public ClientGroup toClientGroup(Group group, Person associatedPerson) {

        final IGroupService.GroupGeoAreaIds groupGeoAreaIds =
                findGeoAreaIdsByGroups(Collections.singleton(group)).values().iterator().next();

        return ClientGroup.builder()
                .id(group.getId())
                .visibility(group.getVisibility())
                .contentVisibility(group.getContentVisibility())
                .accessibility(group.getAccessibility())
                .name(group.getName())
                .shortName(group.getShortName())
                .deleted(group.isDeleted())
                .geoAreaIds(new ArrayList<>(groupGeoAreaIds.getIncludedGeoAreaIds()))
                .logo(toClientMediaItem(group.getLogo()))
                .memberCount(groupMembershipRepository.countByGroupAndStatus(group, GroupMembershipStatus.APPROVED))
                .membershipStatus(groupMembershipRepository.findAll()
                        .stream()
                        .filter(gm -> gm.getGroup().equals(group) && gm.getMember().equals(associatedPerson))
                        .map(GroupMembership::getStatus)
                        .findFirst()
                        .orElse(GroupMembershipStatus.NOT_MEMBER))
                .build();
    }

    public ClientPost toCensoredClientPost(Post post) {
        final ClientPost clientPost = grapevineClientModelMapper.toClientPost(post, false);
        shortenLastName(clientPost);
        return clientPost;
    }

    public ClientComment toCensoredClientComment(Comment comment) {
        final ClientComment clientComment = grapevineClientModelMapper.toClientComment(comment, false);
        shortenLastName(clientComment);
        return clientComment;
    }

    private void shortenLastName(Object clientPost) {
        ObjectGraphWalker.startAt(clientPost)
                .walkAndCall(BaseClientPerson.class, person -> {
                    person.setLastName(shorten(person.getLastName()));
                    return false;
                });
    }

    @FunctionalInterface
    public interface MembershipTestExecution {

        void execute(GroupMembershipStatus membershipStatus) throws Exception;

    }

    public void iterateOverNonMemberGroupMembershipStatus(Person caller, Group restrictedGroup,
            MembershipTestExecution callback) throws Exception {

        //prepared membership entity for restricted group
        GroupMembership membership = GroupMembership.builder()
                .member(caller)
                .group(restrictedGroup)
                .build();
        for (GroupMembershipStatus membershipStatus : Arrays.asList(GroupMembershipStatus.NOT_MEMBER,
                GroupMembershipStatus.PENDING, GroupMembershipStatus.REJECTED)) {

            log.info("Setting membership status of {} in group {} to {}", caller, restrictedGroup, membershipStatus);
            membership.setStatus(membershipStatus);
            membership = groupMembershipRepository.save(membership);

            callback.execute(membershipStatus);
        }
    }

    public void setGroupAccessibilityApprovalRequiredFeatureEnabled(AppVariant appVariant, boolean enabled) {

        FeatureConfig featureConfig = FeatureConfig.builder()
                .appVariant(appVariant)
                .enabled(enabled)
                .featureClass(GroupAccessibilityApprovalRequiredFeature.class.getName())
                .configValues(null)
                .build()
                .withConstantId();
        // it is important that it always has a different timestamp
        featureConfig.setCreated(nextTimeStamp());
        FeatureConfigRepository.save(featureConfig);

        featureService.invalidateCache();
    }

}
